package net.froemling.bsremote;

import java.io.IOException;
import java.io.PrintWriter;
import java.io.StringWriter;
import java.util.ArrayList;
import java.util.List;

import org.apache.http.NameValuePair;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.HttpClient;
import org.apache.http.client.entity.UrlEncodedFormEntity;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.message.BasicNameValuePair;

import android.content.Context;
import android.content.pm.PackageManager.NameNotFoundException;
import android.util.Log;

public class LogThread extends Thread {
	private String _log;
	private String _version;
	static boolean _sent = false;
	static public void log(String s, Throwable e){
		// only report the first error..
		if (!_sent){
			if (e != null){
				StringWriter sw = new StringWriter();
				e.printStackTrace(new PrintWriter(sw));
				if (!s.equals("")) s += "\n";
				s += sw.toString();
			}
			
			new LogThread(ScanActivity.mContext,s).start();
			_sent = true;
		}
        // report all to the standard log
        Log.e("BSREMOTE",s);
        if (e != null) e.printStackTrace();
	}
	public LogThread(Context c, String s){
		super("Error");
		_log = s;
		try {
			if (c == null) _version = "?";
			else _version = c.getPackageManager().getPackageInfo(c.getPackageName(), 0).versionName;
		} catch (NameNotFoundException e) {}
	}
	public void run(){
		HttpClient httpclient = new DefaultHttpClient();
		HttpPost httppost = new HttpPost("http://acrobattleserver.appspot.com/bsRemoteLog");
		try {
			// Add your data
			String userAgent = "BombSquad Remote "+_version+" (Android "+android.os.Build.VERSION.RELEASE+"; "+android.os.Build.MANUFACTURER
					+" "+android.os.Build.MODEL+")";
			;
			httppost.setHeader("User-Agent", userAgent);
			List<NameValuePair> nameValuePairs = new ArrayList<NameValuePair>(2);
			nameValuePairs.add(new BasicNameValuePair("version", _version));
			nameValuePairs.add(new BasicNameValuePair("log", _log));
			httppost.setEntity(new UrlEncodedFormEntity(nameValuePairs));


			// Execute HTTP Post Request
			httpclient.execute(httppost);

		} catch (ClientProtocolException e) {
			// TODO Auto-generated catch block
		} catch (IOException e) {
			// TODO Auto-generated catch block
		}
	}

}
